{****************************************************************************}
{                                                                            }
{        Turbo Pascal Version 4.0                                            }
{        DOSCRT Unit                                                         }
{                                                                            }
{        Copyright (c) 1988 Borland International, Inc.                      }
{                                                { INT 21          ; Call DOS           }


PROCEDURE WriteDOS (C : CHAR);

   INLINE ($B4/$02/                   { MOV AH, 02      ; Code for output    }
           $5A/                       { POP DX          ; Get char for write }
           $CD/$21);                  { INT 21          ; Call dos           }


FUNCTION KeyReadyDOS : BOOLEAN;

   INLINE ($B4/$0B/                   { MOV AH, 0B      ; Code for check     }
           $CD/$21/                   { INT 21          ; Call DOS           }
           $25/$01/$00);              { AND AX, 01      ; Mask first bit     }


{----------------------------------------------------------------------------}

{ Private FAR call procedures and functions }

{ PROCEDURE DOSCrt_1B_23       Interrupt $1B and $23 Intermediate Handler    }
{ PROCEDURE DOSCrt_ExitProc    ExitCode for DOSCrt                           }
{ FUNCTION  DOSCrt_Open        Text File Device Driver Open   Function       }
{ FUNCTION  DOSCrt_In          Text File Device Driver Input  Function       }
{ FUNCTION  DOSCrt_Out         Text File Device Driver Output Function       }
{ FUNCTION  DOSCrt_NUL         Text File Device Driver Close  Function       }

{$F+}


PROCEDURE DOSCrt_1B_23;

   INTERRUPT;

   BEGIN
      IF CheckBreak THEN BEGIN
         INLINE ($E4/$61/$8A/$E0/$0C/$80/$E6/$61/       { Clean up as the    }
                 $86/$E0/$E6/$61/$B0/$20/$E6/$20);      { BIOS would         }
         JmpOldISR (SystemInt23);
      END;   {IF}
   END;   {DOSCrt_1B_23}


PROCEDURE DOSCrt_ExitProc;

   BEGIN
      ExitProc:=DOSCrt_OldExitProc;
      SetIntVec ($23,SystemInt23);
      SetIntVec ($1B,SaveInt1B);
   END;   {DOSCrt_ExitProc}


FUNCTION DOSCrt_NUL (VAR F : TextRec) : INTEGER;

   BEGIN
      DOSCrt_NUL:=0;
   END;   {DOSCrt_NUL}


FUNCTION DOSCrt_IN (VAR F : TextRec) : INTEGER;

   VAR
      P       : WORD;
      NotDone : BOOLEAN;

   BEGIN   {DOSCrt_IN}
      WITH F DO BEGIN
         P:=0;
         NotDone:=TRUE;
         WHILE NotDone AND (P < BufSize) DO BEGIN
            BufPtr^[P]:=ReadDOSEcho;
            IF BufPtr^[P] = #13 THEN BEGIN
               INC (P);
               BufPtr^[P]:=#10;
               WriteDOS (#10);
               NotDone:=FALSE;
            END;   {IF}
            INC (P);
         END;   {WHILE}
         BufPos:=0;
         BufEnd:=P;
      END;   {WITH}
      DOSCrt_IN:=0;
   END;   {DOSCrt_In}


FUNCTION DOSCrt_OUT (VAR F : TextRec) : INTEGER;

   VAR
      P : WORD;

   BEGIN   {DOSCrt_OUT}
      WITH F DO BEGIN
         P:=0;
         WHILE (P < BufPos) DO BEGIN
            WriteDOS (BufPtr^[P]);
            INC (P);
         END;   {WHILE}
         BufPos:=0;
      END;   {WITH}
      DOSCrt_OUT:=0;
   END;   {DOSCrt_OUT}


FUNCTION DOSCrt_Open (VAR F : TextRec) : INTEGER;

   BEGIN   {DOSCrt_Open}
      WITH F DO BEGIN
         IF Mode = fmInput
            THEN BEGIN
               InOutFunc:=@DOSCrt_In;
               FlushFunc:=@DOSCrt_NUL;
            END   {THEN}
            ELSE BEGIN
               Mode:=fmOutput;
               InOutFunc:=@DOSCrt_Out;
               FlushFunc:=@DOSCrt_Out;
            END;   {ELSE}
         CloseFunc:=@DOSCrt_NUL;
      END;   {WITH}
      DOSCrt_Open:=0;
   END;   {DOSCrt_Open}


{$F-}

{----------------------------------------------------------------------------}


PROCEDURE AssignCrt (VAR F: Text);

   BEGIN   {AssignCrt}
      WITH TextRec (F) DO BEGIN
         Handle:=$FFFF;
         Mode:=fmClosed;
         BufSize:=SizeOf (Buffer);
         BufPtr:=@Buffer;
         BufEnd:=0;
         BufPos:=0;
         OpenFunc:=@DOSCrt_Open;
         Name[0]:=#0;
      END;   {WITH}
   END;   {AssignCrt}


FUNCTION KeyPressed : BOOLEAN;

   BEGIN   {KeyPressed}
      KeyPressed:=KeyReadyDOS;
   END;   {KeyPressed}


FUNCTION ReadKey : CHAR;

   BEGIN   {ReadKey}
      ReadKey:=ReadDOSNoEcho;
   END;   {ReadKey}


PROCEDURE TextMode (Mode : WORD);

   BEGIN   {TextMode}
      Write (ESCI,'=',Mode,'h');
      LastMode:=Mode;
   END;   {TextMode}


PROCEDURE GotoXY (X,Y : BYTE);

   BEGIN   {GotoXY}
      Write (ESCI,Y,';',X,'H');
   END;   {GotoXY}


FUNCTION WhereX : BYTE;

   VAR
      X,I : BYTE;

   BEGIN   {WhereX}
      Write (ESCI,'6n');
      FOR I:=1 TO 2 DO
         IF ReadKey = #0 THEN;            { ????? WHAT IS THIS FOR ????? }
      X:=(BYTE(ReadKey)-48)*10;          { 48 = ORD('0') }
      WhereX:=X+BYTE(ReadKey)