(****************************************************************************)
(*                                                                          *)
(* Program written by Jeff Falter, SLCHD-NW-ED.                             *)
(*                                                                          *)
(****************************************************************************)
(*                                                                          *)
(* To change the number of points which may be operated upon, the following *)
(* constant(s) must be changed in file Global:                              *)
(*     1. TNArraySize : the maximum number of input points allowed.         *)
(*                                                                          *)
(****************************************************************************)


PROGRAM FFT;

USES
{$IFDEF DOSCrt}
   DOSCrt,
{$ELSE}
   Crt,
{$ENDIF}
   TextOps,
   Global,
   DigitizeWaveform,       { routines for menu option 1, manual digitization }
   FileSystem,             { routines for menu option 2, file I/O operations }
   SignalProcessing,       { routines for menu option 3, signal processing   }
   GraphWaveform,          { routines for menu option 4, graph results       }
   AdvancedOpts,           { routines for menu option 5, advanced options    }
   CreateWaveform;         { routines for menu option 6, create waveform     }


(****************************************************************************)

BEGIN   {FFT}
   (*** First initialize variables. ***)
   Read_DefaultOptions;
   TextColor (ForeColor);
   TextBackground (BackColor);
   ClrScr;
   Initialize_Variables;

   (*** Create windows, show menu, ask choice. ***)
   REPEAT
      MainMenu;
      CASE Choice OF
         '1': AnalyticWaveform;
         '2': FileIO;
         '3': IF ORIG OR TRANS THEN SPS;
         '4': IF ORIG OR TRANS THEN Graph_Wave;
         '5': AdvancedOptions;
         '6': Digitize_Wave;
         ESC: BEGIN   {finished}
                 ClrScr;
                 Release (HeapTop);
                 Exit;
              END;   {finished}
      END;   {CASE}
   UNTIL FALSE;
END.   {FFT}
